__version__ = '0.0.4'

import logging.config
import logging.config
from logging import LoggerAdapter

import rootpath
import watchtower
import yaml

# path = "~/../../"

path = rootpath.detect()
# TODO: consider using this: path = "~/.."


batch_id = ""


def extra_info():
    return {'batch_id': batch_id}


class PDPLoggerAdapter(LoggerAdapter):
    def __init__(self, logger, extra):
        super().__init__(logger, extra)

    def process(self, msg, kwargs):
        kwargs["extra"] = extra_info()
        return msg, kwargs


with open(path + '/logging.yaml', 'r') as log_config:
    config_yml = log_config.read()
    config_dict = yaml.safe_load(config_yml)
    if config_dict["enable_cloudwatch"]:
        logging.config.dictConfig(config_dict)

        logging.basicConfig(format=config_dict["formatters"]["plaintext"]["format"])

        logger = logging.getLogger(config_dict['handlers']['watchtower_log']['stream_name'])
        logger.setLevel(config_dict['handlers']['watchtower_log']['level'])
        logger.addHandler(
            watchtower.CloudWatchLogHandler(log_group=config_dict['handlers']['watchtower_log']['log_group']))

        exception_logger = logging.getLogger(config_dict['handlers']['watchtower_exception']['stream_name'])
        exception_logger.setLevel(config_dict['handlers']['watchtower_exception']['level'])
        exception_logger.addHandler(
            watchtower.CloudWatchLogHandler(log_group=config_dict['handlers']['watchtower_exception']['log_group']))

        # Add exceptions to log group as well
        exception_logger.addHandler(
            watchtower.CloudWatchLogHandler(log_group=config_dict['handlers']['watchtower_log']['log_group']))

    else:
        # logging.basicConfig(filename='app.log', filemode='w', format=config_dict["formatters"]["plaintext"]["format"])
        logging.basicConfig(format=config_dict["formatters"]["plaintext"]["format"])
        logger = logging.getLogger("logger")
        logger = PDPLoggerAdapter(logger, extra_info())
        exception_logger = logging.getLogger("exception_logger")
        exception_logger = PDPLoggerAdapter(exception_logger, extra_info())
        logger.setLevel(config_dict['handlers']['console']['level'])
        exception_logger.setLevel(config_dict['handlers']['console']['level'])
